class DemoPassingMethods
  def square(x)
    x * x
  end

  def cube(x)
    x * x * x
  end

  # this method takes another method as an argument
  def plus_one(x, fxn)
    send(fxn, x) + 1
  end

  # this method takes an optional method argument,
  # with square as the default
  def plus_two(x, fxn = :square)
    send(fxn, x) + 1
  end
end

t = DemoPassingMethods.new

puts t.plus_one(2, :square)       # gives 5
puts t.plus_one(3, :cube)         # gives 28

puts t.plus_two(4)                # gives 17
puts t.plus_two(5, :cube)         # gives 126
